/*-------------------------------------------------------------------*\
  CaseGen.cpp --     
                  0.51 beta
			     () 2002   a.k.a. FighteR

   :
	CaseGen.h    --   
	resource.h   --   
	CaseGen.cpp  --   
	GenProc.cpp  --   
	LoadProg.cpp --     
	Cg.rc        -- 
	casegen.dlg  --   
	Prog.txt     --    ( )
	Prog.doc     --     

  :
        .  
	   .   
	  .
\*-------------------------------------------------------------------*/

#include "CaseGen.h"

#include <commctrl.h>


void InitWindowControls(HWND);
void InitToolTips(HWND, HINSTANCE);

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

HWND  hMainWnd;

static char  szAppName[] = "CaseGen";

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
	MSG          msg;
	WNDCLASSEX   wndclass;

		//  
	if( !LoadProg("Prog.txt"))
	{
		MessageBox(NULL, pszError, szAppName, MB_ICONEXCLAMATION);
		return FALSE;
	}

		//   
	wndclass.cbSize        = sizeof (wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = DLGWINDOWEXTRA;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon (hInstance, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH) (COLOR_3DFACE + 1);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = szAppName;
	wndclass.hIconSm       = LoadIcon (hInstance, IDI_APPLICATION);

	RegisterClassEx (&wndclass);

		//  
	hMainWnd = CreateDialog (hInstance, szAppName, 0, NULL);

	if (!hMainWnd) return FALSE;

	InitWindowControls(hMainWnd);
	InitToolTips(hMainWnd, hInstance);

	ShowWindow (hMainWnd, iCmdShow);
	SetFocus (GetDlgItem (hMainWnd, IDC_EDIT0));

		// message loop
	while (GetMessage (&msg, NULL, 0, 0))
	{
		TranslateMessage (&msg);
		DispatchMessage (&msg);
	}
	return msg.wParam;
}


/*----------------------------------------------------------------*\
     
\*----------------------------------------------------------------*/
void InitWindowControls(HWND hWnd)
{
	const char *aszCaseString[] ={
		"",
		" ",
		" ",
		" ",
		" ",
		" "
	};

	for(int i = GENITIVE; i <= PREPOSITIONAL; i++)
	{
		CheckDlgButton(hWnd, IDC_CHECK0 + i, BST_CHECKED);
		SetText(i, aszCaseString[i]);
	}

	CheckRadioButton(hWnd, IDC_RADIO1, IDC_RADIO3, IDC_RADIO1);
	CheckRadioButton(hWnd, IDC_RADIO4, IDC_RADIO5, IDC_RADIO4);
	CheckRadioButton(hWnd, IDC_RADIO6, IDC_RADIO7, IDC_RADIO6);
	CheckRadioButton(hWnd, IDC_RADIO8, IDC_RADIO9, IDC_RADIO8);
}


/*----------------------------------------------------------------*\
    
\*----------------------------------------------------------------*/
void InitToolTips(HWND hwndParent, HINSTANCE hInst)
{
	TOOLINFO ti;
	HWND     hwndTip;
	INITCOMMONCONTROLSEX iccex;

	const UINT atoolID[] = {
		IDC_EDIT0,  IDC_EDIT1,  IDC_EDIT2,  IDC_EDIT3,  IDC_EDIT4,  IDC_EDIT5,
		IDC_CHECK0, IDC_CHECK1, IDC_CHECK2, IDC_CHECK3, IDC_CHECK4, IDC_CHECK5,
		IDC_RADIO1, IDC_RADIO2, IDC_RADIO3,
		IDC_RADIO4, IDC_RADIO5,
		IDC_RADIO6, IDC_RADIO7,
		IDC_RADIO8, IDC_RADIO9, 0};

	const UINT atipID[] = {
		IDC_EDIT0,  IDC_EDIT1,  IDC_EDIT2,  IDC_EDIT3,  IDC_EDIT4,  IDC_EDIT5,
		IDC_CHECK0, IDC_CHECK1, IDC_CHECK2, IDC_CHECK3, IDC_CHECK4, IDC_CHECK5,
		IDS_GENDER, IDS_GENDER, IDS_GENDER,
		IDS_NUMBER, IDS_NUMBER,
		IDS_ANIMATE,IDS_ANIMATE,
		IDS_STRESS,	IDS_STRESS, 0};

	iccex.dwSize = sizeof(iccex);
	iccex.dwICC  = ICC_TAB_CLASSES;

	if(!InitCommonControlsEx( & iccex)) return;

	hwndTip = CreateWindowEx(
		NULL, TOOLTIPS_CLASS, NULL,
        WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,
        CW_USEDEFAULT, CW_USEDEFAULT,
        CW_USEDEFAULT, CW_USEDEFAULT,
        hwndParent, NULL, hInst, NULL);

	SetWindowPos(hwndTip, HWND_TOPMOST,0, 0, 0, 0,
				SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

	ti.cbSize = sizeof(ti);
	ti.hwnd   = hwndParent;
	ti.hinst  = hInst;
	ti.uFlags = TTF_SUBCLASS | TTF_IDISHWND;
	
	for (int i = 0; (atoolID[i] != 0) && (atipID[i] != 0); i++)
	{
		ti.lpszText = MAKEINTRESOURCE(atipID[i]);
		ti.uId      = (UINT)GetDlgItem(hwndParent, atoolID[i]);
		if( !SendMessage(hwndTip, TTM_ADDTOOL, 0, (LPARAM) & ti)) return;
	}
	SendMessage(hwndTip, TTM_ACTIVATE, (WPARAM)TRUE, 0);
}


static bool bUserInput = true;

/*----------------------------------------------------------------*\
  Window Procedure
\*----------------------------------------------------------------*/
LRESULT CALLBACK WndProc (HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(iMsg)
	{
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_EDIT0:
					switch(HIWORD(wParam))
					{
						case EN_UPDATE:
							if(bUserInput) Generate();
							return 0;
					}
					break;

				case IDC_EDIT1:
				case IDC_EDIT2:
				case IDC_EDIT3:
				case IDC_EDIT4:
				case IDC_EDIT5:
					switch(HIWORD(wParam))
					{
						case EN_UPDATE:
							if(bUserInput) CheckDlgButton(hWnd,
									IDC_CHECK0 + (LOWORD(wParam) - IDC_EDIT0), BST_UNCHECKED);
							return 0;
					}
					break;

				case IDC_CHECK0: case IDC_CHECK1: case IDC_CHECK2:
				case IDC_CHECK3: case IDC_CHECK4: case IDC_CHECK5:
				case IDC_RADIO1: case IDC_RADIO2: case IDC_RADIO3:
				case IDC_RADIO4: case IDC_RADIO5:
				case IDC_RADIO6: case IDC_RADIO7:
				case IDC_RADIO8: case IDC_RADIO9:
					Generate();
					return 0;

				case IDC_EXIT:
					DestroyWindow(hWnd);
					return 0;
			}
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
    }
	return DefWindowProc (hWnd, iMsg, wParam, lParam);
}


bool IsChecked(int iCheckBox)
{
	return (BST_CHECKED == IsDlgButtonChecked(hMainWnd, IDC_CHECK0 + iCheckBox));
}


void GetText(int iEdit, LPSTR szBuffer)
{
	GetDlgItemText(hMainWnd, IDC_EDIT0 + iEdit, szBuffer, MAX_STRLEN);
}


void SetText(int iEdit, LPCSTR szText)
{
	bUserInput = false;
	SetDlgItemText (hMainWnd, IDC_EDIT0 + iEdit, szText);
	bUserInput = true;
}


void SetMemoText(LPCSTR szText)
{
	SetDlgItemText (hMainWnd, IDC_MEMO, szText);
}


void SetDebugText(LPSTR szText)
{
	SetDlgItemText (hMainWnd, IDC_DEBUG_TEXT, szText);
}


int GetGender(void)
{
	if (BST_CHECKED == IsDlgButtonChecked(hMainWnd, IDC_RADIO1)) return MASCULINE;
	if (BST_CHECKED == IsDlgButtonChecked(hMainWnd, IDC_RADIO2)) return FEMININE;
	return NEUTER;
}


int GetNumber(void)
{
	if (BST_CHECKED == IsDlgButtonChecked(hMainWnd, IDC_RADIO4)) return SINGL;
	return PLURAL;
}


int GetAnimate(void)
{
	if (BST_CHECKED == IsDlgButtonChecked(hMainWnd, IDC_RADIO6)) return INANIMATE;
	return ANIMATE;
}


int GetStress(void)
{
	if (BST_CHECKED == IsDlgButtonChecked(hMainWnd, IDC_RADIO8)) return STRESSED;
	return UNSTRESSED;
}
