/*-------------------------------------------------------------------*\
      
	 0.51 beta
	() 2002   a.k.a. FighteR
  
  GenProc.cpp  --   
\*-------------------------------------------------------------------*/

#include "CaseGen.h"


LPSTR aszCaseLogic[7];				// 6  + _ 
char aszVarString[10][MAX_STRLEN];


void VRTADS(int iGender, int iNumber)		//   RTADS
{
	int iCase, i;
	bool bUnique;
	char szMemo[6 * MAX_STRLEN];
	char aszBuffer[6][MAX_STRLEN];
	char achDesc[] = "srdvtp";

	lstrcpy(szMemo, "");
	for(iCase = NOMINATIVE; iCase <= PREPOSITIONAL; iCase++)
	{
		GetText (iCase, aszBuffer[iCase]);
		sprintf (szMemo + lstrlen(szMemo),
			"%cdesc =\"%s\"\r\n", achDesc[iCase], aszBuffer[iCase]);
	}
	lstrcat(szMemo, "noun ='");
	for (iCase = NOMINATIVE; iCase <= INSTRUMENTAL ; iCase++)
	{
			//   
		bUnique = true;
		for (i = iCase + 1; i <= PREPOSITIONAL; i++)
		{
			if (0 == lstrcmp(aszBuffer[iCase], aszBuffer[i]))
			{
				bUnique = false;
				break;
			}
		}
		if (bUnique)
		{
			GetText (iCase, szMemo + lstrlen(szMemo));
			lstrcat (szMemo, "' '");
		}
	}
	lstrcat(szMemo, aszBuffer[PREPOSITIONAL]);
	lstrcat(szMemo, "'\r\n");

	if (GetNumber() == PLURAL)    lstrcat(szMemo, "isThem = true\r\n");
	if (GetGender() == MASCULINE) lstrcat(szMemo, "isHim = true\r\n");
	if (GetGender() == FEMININE)  lstrcat(szMemo, "isHer = true\r\n");
	
	SetMemoText(szMemo);
}


bool ContainsSzCh(LPCSTR szString, char ch)
{
	int i = 0;
	while(szString[i]) if (ch == szString[i++]) return true;
	return false;
}


bool IsWhiteSpace(char ch)
{
	return ((UCHAR)ch <= (UCHAR)' ' || ch == '.' || ch == ',' || ch == ';' || ch == ':');
}


/*----------------------------------------------------------------*\
      
\*----------------------------------------------------------------*/
int WordsCount(LPCSTR szString)
{
	int  iCount = 0;
	bool bWasLetter = false;
	int  i;
	for(i = 1; i <= lstrlen(szString); i++)
	{
		if( IsWhiteSpace(szString[i]) || szString[i] == '\0')
		{
			if(bWasLetter){
				iCount++;
				bWasLetter = false;
			}
		}else bWasLetter = true;
	}
	return iCount;
}



/*----------------------------------------------------------------*\
       ,     
\*----------------------------------------------------------------*/
void TakeWord(int iWordNeed, LPSTR szBuffer, LPCSTR szString)
{
	int i, iBeg = 0, iCount = 0;
	bool bWasLetter = false;

	for(i = 0; i <= lstrlen(szString); i++)
	{
		if (IsWhiteSpace (szString[i]) || szString[i] == '\0') //   
		{
			if (bWasLetter)     //   ?
			{
				if( ++iCount == iWordNeed)
				{	//   
					lstrcpyn(szBuffer, szString + iBeg, i - iBeg + 1);
					return;
				}
			}
			bWasLetter = false;
		}else{
			if(! bWasLetter) iBeg = i;
			bWasLetter = true;
		}
	}
	lstrcpy(szBuffer, "");	//     !
}



int DetectGender(LPCSTR szWord)
{
	if (lstrlen(szWord) > 1){
		switch (szWord[lstrlen(szWord) - 1])
		{
			case '':						return MASCULINE;
			case '': case '': case '':	return NEUTER;		//  -  !
		}
	}
	return GetGender();
}



bool CompareCh(char ch, char ch2)
{
	switch(ch2)
	{
		case '_': return true; 
		default:
			if(ch2 >= '0' && ch2 <= '9')
				return ContainsSzCh(aszVarString[((UINT)ch2 - '0')], ch);

			return (ch == ch2);
	}
}

void ChangeCh(char & ch, char ch2)
{
	switch(ch2)
	{
		case '_': break;
		default: ch = ch2;
	}
}


/*----------------------------------------------------------------*\
     szWord   szEnding,
         szNew
\*----------------------------------------------------------------*/
bool TryEnd(LPSTR szWord, LPSTR szEnding, LPSTR szNew)
{
	int i;
	int iOffset = lstrlen(szWord) - lstrlen(szEnding);

		//
	if( iOffset < 0 ) return false;
	for( i = 0; i < lstrlen(szEnding); i++)
	{
		if( !CompareCh (szWord[iOffset + i], szEnding[i])) return false;
	}
		//   -
	for( i = 0; i <= lstrlen(szNew); i++)
	{
		ChangeCh (szWord[iOffset + i], szNew[i]);
	}
	return true;
}


/*----------------------------------------------------------------*\
     szWord  
        szProg
\*----------------------------------------------------------------*/
bool ParseLogic(LPSTR szWord, WORDPARAM *pWordParam, bool bAllCases, LPSTR szDebugText)
{
	LPCSTR szProg = (bAllCases ? aszCaseLogic[ALL_CASES] : aszCaseLogic[pWordParam->iCase]);
	char szEnd[MAX_STRLEN], szNew[MAX_STRLEN];
	
	int i, nMask, iStatBeg, iStatEnd = 0;

	for(;;)
	{
		iStatBeg = iStatEnd;
		while(szProg[iStatEnd] != ';' && szProg[iStatEnd] != '\0') iStatEnd++;
		if ('\0' == szProg[iStatEnd]) return false;

		for(i = iStatBeg; i < iStatEnd; i++)
		{
			switch(szProg[i])
			{
				case 'M': if(pWordParam->iGender  != MASCULINE)  goto next_stat; break;
				case 'F': if(pWordParam->iGender  != FEMININE)   goto next_stat; break;
				case 'N': if(pWordParam->iGender  != NEUTER)     goto next_stat; break;
				case 'S': if(pWordParam->iNumber  != SINGL )     goto next_stat; break;
				case 'P': if(pWordParam->iNumber  != PLURAL)     goto next_stat; break;
				case 'I': if(pWordParam->iAnimate != INANIMATE)  goto next_stat; break;
				case 'A': if(pWordParam->iAnimate != ANIMATE)    goto next_stat; break;
				case 'U': if(pWordParam->iStress  != UNSTRESSED) goto next_stat; break;
				case 'L': if( !pWordParam->bIsLast)              goto next_stat; break;
				default:
					if((UCHAR)szProg[i] <= (UCHAR)' ')
					{
						iStatBeg = i; break;
					}
					
					TakeWord(1, szEnd, szProg + i);
					
					if(bAllCases)
					{
						switch(pWordParam->iCase)
						{
							case NOMINATIVE:    nMask = 2; break;
							case GENITIVE:      nMask = 3; break;
							case DATIVE:        nMask = 4; break;
							case ACCUSATIVE:    nMask = 5 + pWordParam->iAnimate; break;
							case INSTRUMENTAL:  nMask = 7; break;
							case PREPOSITIONAL: nMask = 8; break;
						}
					}else nMask = 2;

					TakeWord(nMask, szNew, szProg + i);

					if( szEnd == NULL || szNew == NULL ) //   
						goto next_stat;

					if (TryEnd(szWord, szEnd, szNew))
					{
						lstrcpyn(szDebugText, szProg + iStatBeg, iStatEnd - iStatBeg + 1);
						return true;
					}
					goto next_stat;
			}
		}
next_stat:
		iStatEnd++;	//  ';'
	}
}



/*----------------------------------------------------------------*\
   
\*----------------------------------------------------------------*/
void Generate(void)
{
	char szWord     [MAX_STRLEN];
	char szBuffer   [MAX_STRLEN];
	char szDebugText[MAX_STRLEN];
	char szNomString[MAX_STRLEN]; GetText(NOMINATIVE, szNomString);

	WORDPARAM WordParam;
	
	WordParam.iNumber  = GetNumber();
	WordParam.iAnimate = GetAnimate();
	WordParam.iStress  = GetStress();
	
	int iCase;
	int iWord;
	int iWordCount = WordsCount(szNomString);
	
		// "  " -  ParseLogic()    
	lstrcpy(szDebugText, "???");

	if (lstrlen(szNomString) <= 1) return;

	if (IsChecked(NOMINATIVE))
	{
		for(iCase = GENITIVE; iCase <= PREPOSITIONAL; iCase++)
			SetText(iCase, szNomString);
	}else{
		for(iCase = GENITIVE; iCase <= PREPOSITIONAL; iCase++)
		{
			if ( !IsChecked(iCase)) continue;

			WordParam.iCase = iCase;
		
			lstrcpy(szBuffer, "");

			for(iWord = 1; iWord <= iWordCount; iWord++)
			{
				TakeWord(iWord, szWord, szNomString);

				WordParam.iGender = DetectGender(szWord);
				WordParam.bIsLast = (iWord == iWordCount);
			
					//       ...
				if( !ParseLogic(szWord, & WordParam, false, szDebugText))
				{
						//     ...
					ParseLogic(szWord, & WordParam, true, szDebugText);
				}

				if (iWord > 1)
					lstrcat(szBuffer, " ");
				lstrcat(szBuffer, szWord);
			}
			SetText(iCase, szBuffer);
		}
	}
	VRTADS(GetGender(), WordParam.iNumber);
	SetDebugText(szDebugText);
}
